const functions = require("../Functions");

function SMSReceived(args)
{
    const url = this.URL + "/sms/received";

    this.TimePeriod = 1440;

    for(let name in args)
    {
        this[name] = args[name];
    }

    // Send message & fire callback when response comes back
    this.Poll = (callback) => {

        if( this.Validated() )
        {
            let data = JSON.stringify({
                "Sender": this.Sender,
                "APIKey": this.APIKey,
                "TimePeriod": this.TimePeriod
            });
    
            functions.HttpRequest(url,data,callback);
        }
        else
        {
            callback({
                "Result": "Error",
                "ErrorMessage": this.Error
            });
        }
    };

    this.Validated = () => {

        if( functions.isEmpty(this.Sender) )
        {
            this.Error = "Missing Sender";
            return false;
        }
        if( functions.isEmpty(this.APIKey) )
        {
            this.Error = "Missing APIKey";
            return false;
        }
        if( functions.isEmpty(this.TimePeriod) )
        {
            this.Error = "Missing TimePeriod";
            return false;
        }
        if( !functions.isNumber(this.TimePeriod) )
        {
            this.Error = "TimePeriod must be a number - number of minutes";
            return false;
        }

        return true;
    };

    return this;
}

module.exports = SMSReceived;